/* --------------------------------------------------------------------------------
   LavA - A Runtime Platform for Application-Specific Distributed Architectures

   Copyright (C) 2009-2012  Embedded System Software Group, Computer Science 12,
   TU Dortmund, <http://ess.cs.tu-dortmund.de/EN/Research/Projects/LavA/>

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program. If not, see <http://www.gnu.org/licenses/>.
   -------------------------------------------------------------------------------- */


#ifndef __main_h__
#define __main_h__


/* IO-Adrressen */
#define UART_RX			((volatile int*)0x80101004)
#define UART_TX			((volatile int*)0x80101008)

#define OUTPORT			((volatile int*)0x80401000)

#define INTERRUPT_STAT	((volatile int*)0x80000004)
#define INTERRUPT_ENA	((volatile int*)0x80000008)
#define INTERRUPT_CTRL 	((volatile int*)0x8000000c)

#define IPC_STAT 		((volatile int*)0x88000800)
#define IPC_DATA 		((volatile int*)0x88000804)
#define IPC_ADDR 		((volatile int*)0x88000808)


volatile int interrupt = 0;
volatile int data = 0;
volatile int addr = 0;


void uart_handle_rx_irq();
void ipc_handle_rx_irq();
void uart_putc(char c);
void uart_puthex(uint32_t c, uint8_t bytes);
void uart_puts(const char *s);
void init(void);


#endif /* __main_h__ */
